%a 4000
%e 4000
%p 4000
%{
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <mixasm.h>
#include <mixal.h>
#include <string.h>

char label[11] = " ";
char *ptr;

int afteralf; 
char alfbuf[6];
 
static char *
copy_alf(char *ptr, int size)
{
     int i;
     for (i = 0; i < size; i++)
	  alfbuf[i] = ptr[i];
     for (; i < sizeof(alfbuf)-1; i++)
	  alfbuf[i] = ' ';
     alfbuf[i] = 0;
     return alfbuf;
}
	  
%}

symbol [A-Z0-9]*[A-Z][A-Z0-9]*
opcod1 NOP|ADD|SUB|MUL|DIV|NUM|CHAR|HLT|SLA|SRA|SLAX|SRAX|SLC
opcod2 {opcod1}|SRC|MOVE|LDA|LD1|LD2|LD3|LD4|LD5|LD6|LDX|LDAN
opcod3 {opcod2}|LD1N|LD2N|LD3N|LD4N|LD5N|LD6N|LDXN|STA|ST1|ST2|ST3
opcod4 {opcod3}|ST4|ST5|ST6|STX|STJ|STZ|JBUS|IOC|IN|OUT|JRED
opcod5 {opcod4}|JMP|JSJ|JOV|JNOV|JL|JE|JG|JGE|JNE|JLE|JAN
opcod6 {opcod5}|JAZ|JAP|JANN|JANZ|JANP|J1N|J1Z|J1P|J1NN|J1NZ|J1NP
opcod7 {opcod6}|J2N|J2Z|J2P|J2NN|J2NZ|J2NP|J3N|J3Z|J3P|J3NN|J3NZ
opcod8 {opcod7}|J3NP|J4N|J4Z|J4P|J4NN|J4NZ|J4NP|J5N|J5Z|J5P|J5NN
opcod9 {opcod8}|J5NZ|J5NP|J6N|J6Z|J6P|J6NN|J6NZ|J6NP|JXN|JXZ|JXP
opcoda {opcod9}|JXNN|JXNZ|JXNP|INCA|DECA|ENTA|ENNA|INC1|DEC1|ENT1|ENN1
opcodb {opcoda}|INC2|DEC2|ENT2|ENN2|INC3|DEC3|ENT3|ENN3|INC4|DEC4|ENT4
opcodc {opcodb}|ENN4|INC5|DEC5|ENT5|ENN5|INC6|DEC6|ENT6|ENN6|INCX|DECX
opcode {opcodc}|ENTX|ENNX|CMPA|CMP1|CMP2|CMP3|CMP4|CMP5|CMP6|CMPX
pseudo EQU|ORIG|CON|END
number [0-9]+
asterisk \*
slashes \/\/
%s  COMMENT
%s  OP
%s  ADDRESS
%%
^{symbol} {
     if (strlen(yytext) > 10) {
	  yyerror("Symbol greater than 10 characters");
	  yytext[10] = '\0';
     }
     if (yylval.symp = lookup(yytext)) {
	  if (yylval.symp->type != UNDEF)
	       if ( strlen(yytext) != 2
		    || yytext[0] < '0'
		    || yytext[0] > '9'
		    || yytext[1] != 'H' ) 
		    yyerror("Duplicate symbol");
	       else yylval.symp = install(yytext,0,0);
     } else {
	  yylval.symp = install(yytext,0,0);
	  yylval.symp->type = UNDEF;
     }  
     strcpy(label,yytext);
     return LOC;
}

^\*       { BEGIN(COMMENT); tlist( "*"); return ASTERISK;}

<COMMENT>[^\n]* {
     if (!isspace(yytext[0]) && afteralf) {
	  if (isspace(alfbuf[0]))
	       yyerror("Literal sequence too long (Too many spaces after ALF?)");
	  else
	       yyerror("Literal sequence too long");
	  afteralf = 0;
	  BEGIN(INITIAL);
	  return BOGUS;
     } else {
	  yylval.txt = yytext;
	  tlist( "%s", yytext);
	  return TEXT;
     }
}

<COMMENT>\n {
     BEGIN(INITIAL);
     afteralf = 0;   
     tlist("\n");
     return yytext[0];
}

<INITIAL>[ \t]+ {
     tlist("%-10s ",label);
     strcpy(label," ");
     BEGIN(OP);
}

<OP>{opcode} {
     yylval.txt = yytext; tlist("%-4s ",yytext);
     return OPCODE;
}

<OP>{pseudo} {
     yylval.txt = yytext; tlist("%-4s ",yytext);
     return PSEUDO;
}

<OP>ALF[ ]*[\n]      {
     yylval.txt = "    ";
     tlist("ALF  %s",yylval.txt);
     unput('\n');
     BEGIN(COMMENT);
     return ALF;
}

<OP>ALF[ ][ ].     |
<OP>ALF[ ][ ]..    |
<OP>ALF[ ][ ]...   |
<OP>ALF[ ][ ]....  |
<OP>ALF[ ][ ].....   {  /* .{1,5} doesn't seem to work */
     yylval.txt = copy_alf(yytext+5, yyleng-5);
     tlist("ALF  %s",yylval.txt);
     afteralf = 1;
     BEGIN(COMMENT);
     return ALF;
}

<OP>ALF[ ][^ ]     |
<OP>ALF[ ][^ ].    |
<OP>ALF[ ][^ ]..   |
<OP>ALF[ ][^ ]...  |
<OP>ALF[ ][^ ]....   {
     yylval.txt = copy_alf(yytext+4, yyleng-4);
     tlist("ALF  %s",yylval.txt);
     afteralf = 1;
     BEGIN(COMMENT);
     return ALF;
}

<OP>[ \t]+ { BEGIN(ADDRESS); } 

<OP>[^ \t\n]+ { yyerror("Invalid op code"); }

<ADDRESS>{symbol} {
     if (strlen(yytext) > 10) {
	  yyerror("Symbol longer than 10 characters");
	  yytext[10] = '\0';
     }
     tlist("%s",yytext);
     if (!(yylval.symp = lookup(yytext))) {
	  yylval.symp = install(yytext,0,0);
	  yylval.symp->type = UNDEF;
	  if ( yytext[0] >= '0' && yytext[0] <= '9' &&
	       yytext[1] == 'B' && yytext[2] == '\0' ) {
	       yylval.symp->type = DEF;
	       return LOCAL_SYMBOL;
	  }
	  else
	       return FUTURE_REFERENCE; 
     }
     else if ( yytext[0] >= '0' && yytext[0] <= '9' &&
	       yytext[1] == 'B' && yytext[2] == '\0' )
	  return LOCAL_SYMBOL;
     else if (yylval.symp->type == UNDEF)
	  return FUTURE_REFERENCE;
     else
	  return DEFINED_SYMBOL;
}

<ADDRESS>{number}   {
     if (strlen(yytext) > 10) {
	  yyerror("Number greater than 10 digits");
	  yytext[10] = '\0';
     }
     tlist("%s",yytext);
     yylval.val = atoi(yytext);
     if (yylval.val > 1073741823)
	  yyerror("Number greater than 1073741823");
     return NUMBER;
}

<ADDRESS>{asterisk} { tlist("*"); return ASTERISK; }

<ADDRESS>{slashes}  { tlist("//"); return SLASHES; }

<ADDRESS>[^ \t\n]   { tlist("%c",*yytext); return yytext[0]; }

<ADDRESS>[ \t]*     { tlist("%s",yytext); BEGIN(COMMENT); } 

<ADDRESS>[\n] { BEGIN(INITIAL); tlist("\n"); return yytext[0]; }

[ \t\n]       { BEGIN(INITIAL); tlist("%c",yytext[0]); return yytext[0]; }
%%

int
yywrap()
{
     return 1;
}

void
init_lex(FILE *fp, int debug)
{
#ifdef FLEX_DEBUG
     yy_flex_debug = debug;
#endif
     yyin = fp;
}
